﻿namespace libfisp
{
    public class UploadingProgress
    {
        public string File { get; }

        public double Progress { get; }

        public UploadingProgress(string file, double progress)
        {
            File = file;
            Progress = progress;
        }
    }

    public class UploadTask
    {
        public event EventHandler<UploadingProgress>? UploadingProgress;

        public event EventHandler<double>? TotalProgress;

        public event EventHandler? Successed;
        
        public event EventHandler<string>? Failed;

        internal void UpdateTotalProgress(double progress)
        {
            TotalProgress?.Invoke(this, progress);
        }

        internal void UpdateUploadProgress(string file, double progress)
        {
            UploadingProgress?.Invoke(this, new UploadingProgress(file, progress));
        }

        internal void UpdateSuccess()
        {
            Successed?.Invoke(this, EventArgs.Empty);
        }

        internal void UpdateFailed(string message)
        {
            Failed?.Invoke(this, message);
        }
    }
}
